#ifndef _cspublic_h_
#define _cspublic_h_

#include <tds.h>

#ifdef __cplusplus
extern "C" {
#endif 

static char  rcsid_cspublic_h [ ] =
         "$Id: cspublic.h,v 1.10 1999/01/23 19:28:48 camber Exp $";
static void *no_unused_cspublic_h_warn[]={rcsid_cspublic_h, no_unused_cspublic_h_warn};


typedef int CS_RETCODE ;

typedef TDS_INT CS_INT;
typedef TDS_SMALLINT CS_SMALLINT;
typedef TDS_TINYINT CS_TINYINT;
typedef TDS_CHAR CS_CHAR;
typedef float CS_REAL;
typedef double CS_FLOAT;
typedef char CS_BOOL;
typedef void CS_VOID;

#define CS_SUCCEED TDS_SUCCEED
#define CS_SIZEOF(x) sizeof(x)

/* FIX ME */
#define CS_NUMBER(x) (x)
#define CS_ORIGIN(x) (x)
#define CS_LAYER(x) (x)
#define CS_SEVERITY(x) (x)

typedef struct cs_context
{
	int dummy;
} CS_CONTEXT;

typedef struct cs_connection
{
	CS_CONTEXT *ctx;
	void *tds_login;
	TDSSOCKET *tds_socket;
} CS_CONNECTION;

typedef struct cs_command
{
	CS_CHAR *query;
	int cmd_done;
	CS_CONNECTION *con;
} CS_COMMAND;

#define CS_MAX_MSG 1024
#define CS_MAX_NAME 132
#define CS_MAX_PREC 77  /* used by php */

typedef struct cs_locale {
	int dummy;	
} CS_LOCALE;

typedef struct cs_datafmt {
	int datatype;
	int format;
	int maxlength;
	int count;
	CS_LOCALE *locale;
	int precision;
	int scale;
	int namelen;
	char name[CS_MAX_NAME];
	int status;
	int usertype;
} CS_DATAFMT;

typedef struct cs_money {
	int dummy;
} CS_MONEY;

typedef struct cs_money4 {
	int dummy;
} CS_MONEY4;

typedef struct cs_datetime {
	int dummy;
} CS_DATETIME;

typedef struct cs_datetime4 {
	int dummy;
} CS_DATETIME4;

typedef struct cs_daterec {
	CS_INT datesecond;
	CS_INT dateminute;
	CS_INT datehour;
	CS_INT datedmonth;
	CS_INT datemonth;
	CS_INT dateyear;
	CS_INT dateweek;
	CS_INT datedweek;
	CS_INT datemsecond;
} CS_DATEREC;

typedef struct cs_clientmsg {
	int severity;
	int msgnumber;
	char msgstring[CS_MAX_MSG];
	long osnumber;
	int osstringlen;
	char osstring[CS_MAX_MSG]; 
} CS_CLIENTMSG;

typedef struct cs_servermsg {
	int severity;
	int msgnumber;
	int state;
	int line;
	int svrnlen;
	char svrname[CS_MAX_NAME];
	int proclen;
	char proc[CS_MAX_NAME];
	char text[CS_MAX_MSG];
	int status;
} CS_SERVERMSG;

/* status bits for CS_SERVERMSG */
#define CS_HASEED 0x01

typedef struct cs_blkdesc {
	int dummy;	
} CS_BLKDESC;

/* CS_CAP_REQUEST values */
#define CS_CON_INBAND	1
#define CS_CON_OOB	2
#define CS_CSR_ABS	3
#define CS_CSR_FIRST	4
#define CS_CSR_LAST	5
#define CS_CSR_MULTI	6
#define CS_CSR_PREV	7
#define CS_CSR_REL	8
#define CS_DATA_BIN	9
#define CS_DATA_VBIN	10
#define CS_DATA_LBIN	11
#define CS_DATA_BIT	12
#define CS_DATA_BITN	13
#define CS_DATA_BOUNDARY	14
#define CS_DATA_CHAR	15
#define CS_DATA_VCHAR	16
#define CS_DATA_LCHAR	17
#define CS_DATA_DATE4	18
#define CS_DATA_DATE8	19
#define CS_DATA_DATETIMEN	20
#define CS_DATA_DEC	21
#define CS_DATA_FLT4	22
#define CS_DATA_FLT8	23
#define CS_DATA_FLTN	24
#define CS_DATA_IMAGE	25
#define CS_DATA_INT1	26
#define CS_DATA_INT2	27
#define CS_DATA_INT4	28
#define CS_DATA_INTN	29
#define CS_DATA_MNY4	30
#define CS_DATA_MNY8	31
#define CS_DATA_MONEYN	32
#define CS_DATA_NUM	33
#define CS_DATA_SENSITIVITY	34
#define CS_DATA_TEXT	35
#define CS_OPTION_GET	36
#define CS_PROTO_BULK	37
#define CS_PROTO_DYNAMIC	38
#define CS_PROTO_DYNPROC	39
#define CS_REQ_BCP	40
#define CS_REQ_CURSOR	41
#define CS_REQ_DYN	42
#define CS_REQ_LANG	43
#define CS_REQ_MSG	44
#define CS_REQ_MSTMT	45
#define CS_REQ_NOTIF	46
#define CS_REQ_PARAM	47
#define CS_REQ_URGNOTIF	48
#define CS_REQ_RPC	49
#define CS_DATA_INT8	50
#define CS_DATA_VOID	51
#define CS_CON_LOGICAL	52
#define CS_PROTO_TEXT	53

/* CS_CAP_RESPONSE values */
#define CS_DATA_NOBOUNDARY	1
#define CS_DATA_NOTDSDEBUG	2
#define CS_RES_NOSTRIPBLANKS	3
#define CS_DATA_NOINT8	4
#define CS_DATA_NOINTN	5
#define CS_DATA_NODATETIMEN	6
#define CS_DATA_NOMONEYN	7
#define CS_CON_NOOOB	8
#define CS_CON_NOINBAND	9
#define CS_PROTO_NOTEXT	10
#define CS_PROTO_NOBULK	11
#define CS_DATA_NOSENSITIVITY	12
#define CS_DATA_NOFLT4	13
#define CS_DATA_NOFLT8	14
#define CS_DATA_NONUM	15
#define CS_DATA_NOTEXT	16
#define CS_DATA_NOIMAGE	17
#define CS_DATA_NODEC	18
#define CS_DATA_NOLCHAR	19
#define CS_DATA_NOLBIN	20
#define CS_DATA_NOCHAR	21
#define CS_DATA_NOVCHAR	22
#define CS_DATA_NOBIN	23
#define CS_DATA_NOVBIN	24
#define CS_DATA_NOMNY8	25
#define CS_DATA_NOMNY4	26
#define CS_DATA_NODATE8	27
#define CS_DATA_NODATE4	28
#define CS_RES_NOMSG	29
#define CS_RES_NOEED	30
#define CS_RES_NOPARAM	31
#define CS_DATA_NOINT1	32
#define CS_DATA_NOINT2	33
#define CS_DATA_NOINT4	34
#define CS_DATA_NOBIT	35

#define CS_USERNAME	1
#define CS_NULLTERM	2
#define CS_FMT_NULLTERM	3
#define CS_SET		4
#define CS_UNUSED	5
#define CS_PASSWORD	6
#define CS_LANG_CMD	7
#define CS_ROW_FAIL	9
#define CS_END_DATA	10
#define CS_FAIL		11
#define CS_CMD_SUCCEED	12
#define CS_CMD_FAIL	13
#define CS_CMD_DONE	14
#define CS_END_RESULTS	15
#define CS_VERSION_100	16
#define CS_FORCE_EXIT	17
#define CS_MESSAGE_CB	18
#define CS_CLIENTMSG_CB 19
#define CS_SERVERMSG_CB 20
#define CS_GET		25
#define CS_CON_STATUS 26
#define CS_FORCE_CLOSE 27
#define CS_CONSTAT_CONNECTED 28
#define CS_SYNC_IO	29
#define CS_NETIO	30
#define CS_IFILE	31
#define CS_APPNAME	32
#define CS_HOSTNAME	33
#define CS_PACKETSIZE	34
#define CS_SEC_ENCRYPTION	36
#define CS_LC_ALL	37
#define CS_SYB_LANG	38
#define CS_SYB_CHARSET	39
#define CS_LOC_PROP	40
#define CS_SV_COMM_FAIL	41
#define CS_BULK_LOGIN	42
#define BLK_VERSION_100 CS_VERSION_100
#define CS_BLK_IN	43
#define CS_BLK_OUT	44
#define CS_BLK_BATCH	45
#define CS_BLK_ALL	46
#define CS_BLK_CANCEL	47
#define CS_CANCEL_ALL	48
#define CS_NUMDATA	49
#define CS_CANCEL_ATTN	50
#define CS_PARENT_HANDLE	51
#define CS_COMP_ID	52
#define CS_BYLIST_LEN	53
#define CS_COMP_BYLIST	54
#define CS_COMP_OP	55
#define CS_COMP_COLID	56
#define CS_NO_COUNT	57
#define CS_ROW_COUNT	59
#define CS_OP_SUM	60
#define CS_OP_AVG	61
#define CS_OP_MIN	62
#define CS_OP_MAX	63
#define CS_OP_COUNT	64
#define CS_FMT_UNUSED	66
#define CS_CANCEL_CURRENT	67
#define CS_CANBENULL	72
#define CS_CAPREQUEST	73
#define CS_NULLDATA	75
#define CS_USERDATA	76
#define CS_EED_CMD	77
#define CS_LOGIN_TIMEOUT	78
#define CS_CAP_REQUEST	79
#define CS_DESCRIBE_INPUT	80
#define CS_PREPARE	81
#define CS_EXECUTE	82
#define CS_DEALLOC	83
#define CS_CAP_RESPONSE	84

/* result_types */
#define CS_COMPUTE_RESULT	1
#define CS_CURSOR_RESULT	2
#define CS_PARAM_RESULT		3
#define CS_ROW_RESULT		4
#define CS_STATUS_RESULT	5
#define CS_COMPUTEFMT_RESULT	6
#define CS_ROWFMT_RESULT	7
#define CS_MSG_RESULT		8
#define CS_DESCRIBE_RESULT	9

/* bind types */
#define CS_CHAR_TYPE	1
#define CS_INT_TYPE	2
#define CS_SMALLINT_TYPE	3
#define CS_TINYINT_TYPE	4
#define CS_MONEY_TYPE	5
#define CS_DATETIME_TYPE	6
#define CS_NUMERIC_TYPE	7
#define CS_DECIMAL_TYPE	8
#define CS_DATETIME4_TYPE	9
#define CS_MONEY4_TYPE	10
#define CS_IMAGE_TYPE	11
#define CS_BINARY_TYPE	12
#define CS_BIT_TYPE	13
#define CS_REAL_TYPE	14
#define CS_FLOAT_TYPE	15
#define CS_TEXT_TYPE	16
#define CS_VARCHAR_TYPE	17
#define CS_VARBINARY_TYPE	18
#define CS_LONGCHAR_TYPE	19
#define CS_LONGBINARY_TYPE	20

/* cs_dt_info type values */
#define CS_MONTH	1
#define CS_SHORTMONTH	2
#define CS_DAYNAME	3
#define CS_DATEORDER	4
#define CS_12HOUR	5
#define CS_DT_CONVFMT	6

/* DT_CONVFMT types */
#define CS_DATES_HMS	1
#define CS_DATES_SHORT	2
#define CS_DATES_LONG	3
#define CS_DATES_MDY1	4
#define CS_DATES_MYD1	5
#define CS_DATES_DMY1	6
#define CS_DATES_DYM1	7
#define CS_DATES_YDM1	8
#define CS_DATES_YMD2	9
#define CS_DATES_MDY1_YYYY	10
#define CS_DATES_DMY1_YYYY	11
#define CS_DATES_YMD2_YYYY	12
#define CS_DATES_DMY2	13
#define CS_DATES_YMD1	14
#define CS_DATES_DMY2_YYYY	15
#define CS_DATES_YMD1_YYYY	16
#define CS_DATES_DMY4	17
#define CS_DATES_DMY4_YYYY	18
#define CS_DATES_MDY2	19
#define CS_DATES_MDY2_YYYY	20
#define CS_DATES_DMY3	21
#define CS_DATES_MDY3	22
#define CS_DATES_DMY3_YYYY	23
#define CS_DATES_MDY3_YYYY	24
#define CS_DATES_YMD3	25
#define CS_DATES_YMD3_YYYY	26

/* */
#define CS_FALSE	0
#define CS_TRUE	1

#ifdef __cplusplus
}
#endif 

#endif

